package org.framework.lazy.cloud.network.heartbeat.common.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import org.framework.lazy.cloud.network.heartbeat.common.MessageType;
import org.framework.lazy.cloud.network.heartbeat.common.advanced.tcp.AbstractTcpHandleChannelHeartbeatTypeAdvanced;
import org.framework.lazy.cloud.network.heartbeat.common.advanced.tcp.client.*;
import org.framework.lazy.cloud.network.heartbeat.common.advanced.tcp.server.*;

/**
 * @see MessageType
 */
@Getter
@AllArgsConstructor
public enum MessageTypeEnums {
    /**
     * @see AbstractTcpHandleChannelHeartbeatTypeAdvanced
     */
    TCP_TYPE_HEARTBEAT(MessageType.TCP_TYPE_HEARTBEAT, "心跳"),
    /**
     * @see AbstractHandleTcpClientConnectSuccessTypeAdvanced
     */
    TCP_REPORT_CLIENT_CONNECT_SUCCESS(MessageType.TCP_REPORT_CLIENT_CONNECT_SUCCESS, "上报 客户端连接成功"),
    /**
     * @see AbstractHandleTcpReportDisconnectTypeAdvanced
     */
    TCP_REPORT_CLIENT_DISCONNECTION(MessageType.TCP_REPORT_CLIENT_DISCONNECTION, "上报 客户端断开连接"),
    /**
     * @see AbstractHandleTcpReportStagingOpenedTypeAdvanced
     */
    TCP_REPORT_CLIENT_STAGING_OPENED(MessageType.TCP_REPORT_CLIENT_STAGING_OPENED, "上报 客户端暂存开启"),
    /**
     * @see AbstractHandleTcpReportStagingClosedTypeAdvanced
     */
    TCP_REPORT_CLIENT_STAGING_CLOSED(MessageType.TCP_REPORT_CLIENT_STAGING_CLOSED, "上报 客户端暂存关闭"),
    /**
     * @see AbstractHandleTcpReportServicePermeateClientTransferTypeAdvanced
     */

    TCP_REPORT_CLIENT_TRANSFER(MessageType.TCP_REPORT_CLIENT_TRANSFER, "上报 客户端数据传输（内网穿透数据回传）"),
    /**
     * @see AbstractHandleTcpReportServicePermeateClientRealConnectTypeAdvanced
     */
    TCP_REPORT_SINGLE_CLIENT_REAL_CONNECT(MessageType.TCP_REPORT_SINGLE_CLIENT_REAL_CONNECT, "上报 客户端创建需要代理的真实端口成功"),
    /**
     * @see AbstractHandleTcpReportServicePermeateClientCloseVisitorTypeAdvanced
     */
    REPORT_SINGLE_CLIENT_CLOSE_VISITOR(MessageType.TCP_REPORT_SERVICE_PERMEATE_CLIENT_CLIENT_CLOSE_VISITOR, "上报 客户端关闭一个访客通道"),
    /**
     * @see AbstractHandleTcpReportSingleClientMessage2OtherClientTypeAdvanced
     */
    TCP_REPORT_SINGLE_CLIENT_MESSAGE(MessageType.TCP_REPORT_SINGLE_CLIENT_MESSAGE, "上报 客户端消息到另一个客户端"),
    /**
     * @see AbstractHandleTcpReportServerChannelActiveTypeAdvanced
     */
    TCP_SERVER_CHANNEL_ACTIVE(MessageType.TCP_SERVER_CHANNEL_ACTIVE, "服务端通道 is active"),
    /**
     * @see AbstractHandleTcpReportClusterNodeRegisterTypeAdvanced
     */
    TCP_REPORT_CLUSTER_NODE_REGISTER_MESSAGE(MessageType.TCP_REPORT_CLUSTER_NODE_REGISTER_MESSAGE, "上报 集群注册"),
    /**
     * @see AbstractHandleTcpReportClientTransferServerPermeateChannelConnectionSuccessfulTypeAdvanced
     */
    TCP_REPORT_CLIENT_TRANSFER_SERVER_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL(MessageType.TCP_REPORT_CLIENT_TRANSFER_SERVER_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL, "上报 客户端渗透服务端数据传输通道连接成功"),
    /**
     * @see AbstractHandleTcpReportClientPermeateServerInitTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_SERVER_INIT(MessageType.TCP_REPORT_CLIENT_PERMEATE_SERVER_INIT, "上报 客户端渗透服务端init信息"),
    /**
     * 上报 客户端渗透服务端init close 信息
     * @see AbstractHandleTcpReportClientPermeateServerCloseTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_SERVER_CLOSE(MessageType.TCP_REPORT_CLIENT_PERMEATE_SERVER_CLOSE, "上报 客户端渗透服务端init close 信息"),


    /**
     * 上报 客户端渗透服务端通信通道关闭
     * @see AbstractHandleTcpReportClientPermeateServerTransferCloseTypeAdvanced
     */
    TCP_TCP_REPORT_CLIENT_PERMEATE_SERVER_TRANSFER_CLOSE(MessageType.TCP_TCP_REPORT_CLIENT_PERMEATE_SERVER_TRANSFER_CLOSE, "上报 客户端渗透服务端通信通道关闭"),

    /**
     * 上报 客户端渗透服务端通信传输
     * @see AbstractHandleTcpReportClientPermeateServerTransferTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_SERVER_TRANSFER(MessageType.TCP_REPORT_CLIENT_PERMEATE_SERVER_TRANSFER, "上报 客户端渗透服务端通信传输"),

    /**
     * @see AbstractHandleTcpReportClientPermeateClientInitTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_CLIENT_INIT(MessageType.TCP_REPORT_CLIENT_PERMEATE_CLIENT_INIT, "上报 客户端渗透客户端init信息"),
    /**
     * 上报 客户端渗透客户端init close 信息
     * @see AbstractHandleTcpReportClientPermeateClientCloseTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_CLIENT_CLOSE(MessageType.TCP_REPORT_CLIENT_PERMEATE_CLIENT_CLOSE, "上报 客户端渗透客户端init close 信息"),
    /**
     * 上报 客户端渗透客户端数据传输通道连接成功
     * @see AbstractHandleTcpReportClientTransferClientPermeateChannelConnectionSuccessfulTypeAdvanced
     */
    TCP_REPORT_CLIENT_TRANSFER_CLIENT_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL(MessageType.TCP_REPORT_CLIENT_TRANSFER_CLIENT_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL, "上报 客户端渗透客户端数据传输通道连接成功"),

    /**
     * 上报 客户端渗透客户端数据传输通道init 成功
     * @see AbstractHandleTcpReportClientTransferClientPermeateChannelInitSuccessfulTypeAdvanced
     */
    TCP_REPORT_CLIENT_TRANSFER_CLIENT_PERMEATE_CHANNEL_INIT_SUCCESSFUL(MessageType.TCP_REPORT_CLIENT_PERMEATE_CLIENT_TRANSFER_CHANNEL_INIT_SUCCESSFUL, "上报 客户端渗透客户端数据传输通道init成功"),
    /**
     * 上报 上报客户端渗透客户端数据传输
     * @see AbstractHandleTcpReportClientTransferClientTypeAdvanced
     */
    TCP_REPORT_CLIENT_TRANSFER_CLIENT_REQUEST(MessageType.TCP_REPORT_CLIENT_PERMEATE_CLIENT_TRANSFER_REQUEST, "上报客户端渗透客户端数据传输"),
    /**
     * 上报客户端渗透客户端数据传输结果
     * @see AbstractHandleTcpReportClientTransferClientResponseTypeAdvanced
     */
    TCP_REPORT_CLIENT_TRANSFER_CLIENT_RESPONSE(MessageType.TCP_REPORT_CLIENT_TRANSFER_CLIENT_RESPONSE, "上报客户端渗透客户端数据传输结果"),
    /**
     * 上报客户端渗透客户端通信通道关闭
     *
     * @see AbstractHandleTcpReportClientPermeateClientTransferCloseTypeAdvanced
     */
    TCP_REPORT_CLIENT_PERMEATE_CLIENT_TRANSFER_CLOSE(MessageType.TCP_REPORT_CLIENT_PERMEATE_CLIENT_TRANSFER_CLOSE, "上报客户端渗透客户端通信通道关闭"),
    /**
     * @see AbstractHandleTcpDistributeConnectSuccessNotificationTypeAdvancedHandle
     */
    TCP_DISTRIBUTE_CLIENT_CONNECTION_SUCCESS_NOTIFICATION(MessageType.TCP_DISTRIBUTE_CLIENT_CONNECTION_SUCCESS_NOTIFICATION, "下发 客户端接收连接成功通知"),


    /**
     * @see AbstractHandleTcpDistributeDisconnectTypeAdvancedHandle
     */
    TCP_DISTRIBUTE_CLIENT_DISCONNECTION_NOTIFICATION(MessageType.TCP_DISTRIBUTE_CLIENT_DISCONNECTION_NOTIFICATION, "下发 客户端断开连接通知"),
    /**
     * @see AbstractHandleTcpDistributeStagingOpenedTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_STAGING_OPENED_NOTIFICATION(MessageType.TCP_DISTRIBUTE_CLIENT_STAGING_OPENED_NOTIFICATION, "下发 客户端暂存开启通知"),
    /**
     * @see AbstractHandleTcpDistributeStagingClosedTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_STAGING_CLOSED_NOTIFICATION(MessageType.TCP_DISTRIBUTE_CLIENT_STAGING_CLOSED_NOTIFICATION, "下发 客户端暂存关闭通知"),
    /**
     * @see AbstractHandleTcpDistributeServicePermeateClientTransferTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_TRANSFER(MessageType.TCP_DISTRIBUTE_CLIENT_TRANSFER, "下发 客户端数据传输(内网穿透数据发送)"),
    /**
     * @see AbstractHandleTcpDistributeServicePermeateClientRealConnectTypeAdvanced
     */
    TCP_DISTRIBUTE_SINGLE_CLIENT_REAL_CONNECT(MessageType.TCP_DISTRIBUTE_SINGLE_CLIENT_REAL_CONNECT, "下发 客户端创建需要代理的真实端口"),
    /**
     * @see AbstractHandleTcpDistributeSingleClientRealAutoReadConnectTypeAdvanced
     */
    TCP_DISTRIBUTE_SINGLE_CLIENT_REAL_CONNECT_AUTO_READ(MessageType.TCP_DISTRIBUTE_SINGLE_CLIENT_REAL_CONNECT_AUTO_READ, "下发 客户端代理的真实端口自动读写"),
    /**
     * @see AbstractHandleTcpDistributeSingleClientRealCloseVisitorTypeAdvanced
     */
    TCP_DISTRIBUTE_SINGLE_CLIENT_REAL_CLOSE_VISITOR(MessageType.TCP_DISTRIBUTE_SERVER_PERMEATE_CLIENT_REAL_CLOSE_VISITOR, "下发 客户端关闭代理服务通道"),
    /**
     * @see AbstractHandleTcpDistributeSingleClientMessageTypeAdvanced
     */
    TCP_DISTRIBUTE_SINGLE_CLIENT_MESSAGE(MessageType.TCP_DISTRIBUTE_SINGLE_CLIENT_MESSAGE, "下发 客户端消息"),
    /**
     * @see AbstractHandleTcpClientChannelActiveAdvanced
     */
    CLIENT_CHANNEL_ACTIVE(MessageType.CLIENT_CHANNEL_ACTIVE, "客户端通道 is active"),
    /**
     * @see AbstractHandleTcpDistributeClusterNodeRegisterTypeAdvanced
     */
    TCP_DISTRIBUTE_CLUSTER_NODE_REGISTER_MESSAGE(MessageType.TCP_DISTRIBUTE_CLUSTER_NODE_REGISTER_MESSAGE, "下发 集群注册"),

    /**
     * @see AbstractHandleTcpDistributeClientTransferServerPermeateChannelConnectionSuccessfulTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_TRANSFER_SERVER_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL(MessageType.TCP_DISTRIBUTE_CLIENT_TRANSFER_SERVER_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL, "下发 客户端渗透服务端数据传输通道连接成功"),
    /**
     * @see AbstractHandleTcpDistributeClientPermeateServerInitTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_INIT(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_INIT, "下发 客户端渗透服务端init信息"),

    /**
     * @see AbstractHandleTcpDistributeClientPermeateServerCloseTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_CLOSE(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_CLOSE, "下发 客户端渗透服务端init close信息"),
    /**
     * @see AbstractHandleTcpDistributeClientPermeateServerTransferCloseTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_TRANSFER_CLOSE(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_TRANSFER_CLOSE, "下发 客户端渗透服务端通信通道关闭"),
    /**
     * @see AbstractHandleTcpDistributeClientPermeateServerTransferTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_TRANSFER(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_SERVER_TRANSFER, "下发 客户端渗透服务端通信传输"),

    /**
     * @see AbstractHandleTcpDistributeClientPermeateClientInitTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_INIT(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_INIT, "下发 客户端渗透客户端init信息"),


    /**
     * @see AbstractHandleTcpDistributeClientPermeateClientCloseTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_CLOSE(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_CLOSE, "下发 客户端渗透客户端init close信息"),
    /**
     * @see AbstractHandleTcpDistributeClientTransferClientPermeateChannelConnectionSuccessfulTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_TRANSFER_CLIENT_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL(MessageType.TCP_DISTRIBUTE_CLIENT_TRANSFER_CLIENT_PERMEATE_CHANNEL_CONNECTION_SUCCESSFUL, "下发 客户端渗透客户端数据传输通道连接成功"),
    /**
     * 下发 客户端渗透客户端数据传输通道init 成功
     * @see AbstractHandleTcpDistributeClientTransferClientPermeateChannelInitSuccessfulTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_CHANNEL_INIT_SUCCESSFUL(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_CHANNEL_INIT_SUCCESSFUL, "下发 客户端渗透客户端数据传输通道init 成功"),
    /**
     * 下发客户端渗透客户端数据传输
     * @see AbstractHandleTcpDistributeClientTransferClientRequestTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_REQUEST(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_REQUEST, "下发客户端渗透客户端数据传输"),
       /**
     * 下发客户端渗透客户端数据传输
     * @see AbstractHandleTcpDistributeServicePermeateClientTransferClientResponseTypeAdvanced
     */
       TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_RESPONSE(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_RESPONSE, "下发客户端渗透客户端数据传输"),
    /**
     * 下发客户端渗透客户端通信通道关闭
     *
     * @see MessageTypeEnums#TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_CLOSE
     * @see AbstractHandleTcpDistributeClientPermeateClientTransferCloseTypeAdvanced
     */
    TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_CLOSE(MessageType.TCP_DISTRIBUTE_CLIENT_PERMEATE_CLIENT_TRANSFER_CLOSE, "下发客户端渗透客户端通信通道关闭"),
    ;

    private final byte typeByte;
    private final String desc;
}
